__version__ = 2, 2, 0
__author__ = '竹永康'
__author_email__ = 'zhuyk4@lenovo.com'


class FileSystem:
    """FileSystem was FileDataOperator in a previous life.

    db = FileSystem('db/')

    # Write content to file 'db/test.txt'
    db['test.txt'].content = ...

    # Read content from file 'db/test.txt'
    text = db['test.txt'].content

    # Delete file 'db/test.txt'
    del db['test.txt']

    # Deep directory:
    db['dir1/dir2/test.txt'] = ...
    text = db['dir1/dir2/test.txt'].content

    # Get file information:
    info = db['test.txt'].{name,atime,mtime,ctime,size}
    """

    def __init__(self, root: str):
        """
        @param root:
            Specify a directory path, it could be a relative path.
            If the specified directory does not exist, it is created.
        """

    def __getattr__(self, rel_path: str):
        pass

    def __setattr__(self, rel_path: str, data):
        pass

    def __delattr__(self, rel_path: str):
        pass

    def __getitem__(self, rel_path: str):
        pass

    def __setitem__(self, rel_path: str, data):
        pass

    def __delitem__(self, rel_path: str):
        pass

    def __iter__(self):
        pass


class FileDataOperator:
    """
    db = FileDataOperator('db/')

    # Write content to file 'db/test.txt'
    db['test.txt'] = ...

    # Read content from file 'db/test.txt'
    text = db['test.txt']

    # Delete file 'db/test.txt'
    del db['test.txt']

    # Deep directory:
    db['dir1/dir2/test.txt'] = ...
    text = db['dir1/dir2/test.txt']
    """

    def __init__(self, root: str):
        """
        @param root:
            Specify a directory path, it could be a relative path.
            If the specified directory does not exist, it is created.
        @attention path:
            This property is important because it keeps track of all paths under @param(root).
        """
        self.root: str = gendir(root)
        self.path: dict = fetch_deep_path(self.root)

    def __getattr__(self, name):
        pass

    def __getitem__(self, name):
        pass

    def __setitem__(self, name, value):
        pass

    def __delitem__(self, name):
        pass

    def __iter__(self):
        pass


def Filetor(
        file: str,
        data: 'Any' = None,
        *,
        ftype: 'enum(json, yaml, obj, txt, csv)' = None,
        encoding: str = None,
        many: bool = False,
        dialect: str = None,
        **kw
):
    """
    Writes data to or reads data from a file based on it type.

    @param file:     A file path.
    @param data:     The data to be written to the file, if None,
                     the data is read from the file and return.
    @param ftype:    Specifies File type, otherwise is determined by file suffix name.
    @param encoding: Open the encoding of the file, default UTF-8.
    @param many:     When ftype is yaml.
    @param dialect:  When ftype is csv.

    if @param(data) is None:
        Read contents of @param(file) according to @param(ftype) and return.
    else:
        Write @param(data) to @param(file) according to @param(ftype).
    """


def fetch_deep_path(path: str) -> dict:
    """Get all file and directory paths under @param(path)."""


def joinpath2abs(*a) -> str:
    """Return its absolute path after concatenating the path."""


def dirname(path: str, *, level: int = None) -> str:
    """Culling path from the end according to
    @param(level) default 1, usually used to get the project root path.
    """


def gendir(*a) -> str:
    """Generate path
    Generates a directory based on the passed in value,
    creates it if it does not exist, and returns it.
    """


def genbasedir(*a) -> str:
    """Generate path
    Generates a base directory based on the passed in value,
    creates it if it does not exist, and returns it.
    """


def joinpath(*a) -> str:
    """Splice @param(*a) into a path."""


def abspath(path: str) -> str:
    """Get the full path of @param(path)."""


def basename(path: str) -> str:
    """Gets the filename of @param(path), and
    returns null if the path is not a file."""


def isabs(path: str) -> bool:
    """Whether @param(path) is a absolute path."""


def isdir(path: str) -> bool:
    """Whether @param(path) is a directory."""


def isfile(path: str) -> bool:
    """Whether @param(path) is a file."""


def islink(path: str) -> bool:
    """Whether @param(path) is a link."""


def ismount(path: str) -> bool:
    """Whether @param(path) is a mount."""


def exists(path: str) -> bool:
    """Whether @param(path) exists."""


def rename(old_path: str, new_path: str):
    """Rename @param(old_path) to @param(new_path)."""


def remove(file: str):
    """Remove a file."""


def rmdir(path: str):
    """Remove an empty directory."""


def rmtree(path: str, ignore_errors: bool = False):
    """Recursively delete a directory tree."""


def mkdir(path: str):
    """Make a directory."""


def makedirs(path: str):
    """Recursively create directory."""


def listdir(path: str) -> list:
    """Return all file and directory names under @param(path)."""


def getsize(file: str) -> int:
    """Return the @param(file) size."""


def getatime(file: str) -> float:
    """Return the @param(file) access time."""


def getctime(file: str) -> float:
    """Return the @param(file) created time."""


def getmtime(file: str) -> float:
    """Return the @param(file) modified time."""


class _______i________s________d_______d_______c_______:
    import sys

    __import__(f'{__name__}.i {__name__[6:]}')
    ipack = sys.modules[__name__]
    icode = globals()[f'i {__name__[6:]}']

    for iname, ifunc in globals().items():
        if iname[0] != '_' and hasattr(icode, iname):
            setattr(ipack, iname, getattr(icode, iname))


from typing import Any
